if (parent.accountwindow) {
	blogger = parent.blogger;
	metaWeblog = parent.metaWeblog;
	dsAccounts = parent.dsAccounts;
	var isSidebar = parent.isSidebar;
} else {
	blogger = window.arguments[0];
	metaWeblog = window.arguments[1];
	var itemid = window.arguments[2];
}

var dsPrefs = new PrefsWrapper1("extensions.deepestSender.");
dsPosts = new Object();
var usemeta;

const bloggerbundle = document.getElementById("bloggerbundle");

function Init() {
	if (isSidebar) {
		var titlebox = document.getElementById("titleblogbox");
		titlebox.orient = "vertical";
		titlebox.lastChild.lastChild.setAttribute("flex", 1);
		document.getElementById("formattingbar").orient = "vertical";
	}

	if (metaWeblog.useme) {
		usemeta = true;
		delete metaWeblog.useme;
		doMetaWeblogStuff();
	}

	if (parent.accountwindow) {
		InitPosting();
	} else {
		InitEditing();
	}
}

function InitPosting() {
	if (!usemeta) {
		var bloglist = document.getElementById("bloglist");
		bloglist.appendChild(document.createElement("menupopup"));
		
		for (i = 0; i < blogger.blogs.length; i++) {
			bloglist.appendItem(blogger.blogs[i]["title"]);
		}
		bloglist.selectedIndex = 0;
		blogger.active = bloglist.selectedIndex;
	}
	
	dsMidas.dontautoformat = false;
	
	dsPosts.resetPostParameters();
	
	var savesecs = dsPrefs.getIntPref("SaveDraftEvery") * 1000;
	if (!isSidebar) {
		dsDraft.loadDraft();
		blogger.saveinterval = setInterval("dsDraft.saveDraft();", savesecs);
	}
	dsMidas.lookForBloggedPage();
	// Have to do this so backspace works if there's a previous post + it doesn't always force CSS.
	var midas = document.getElementById("message");
	midas.contentDocument.designMode = "On";
	midas.contentDocument.execCommand("styleWithCSS", false, dsPrefs.getBoolPref("UseCSS"));
}

function WindowClosing() {
	if ((parent.accountwindow) && (!isSidebar) && (!blogger.editmode)) {
		dsDraft.saveDraft();
	}
}

dsPosts.sendPost = function() {
	if (this.posting) {
		this.posting = false;
		if (usemeta) {
			metaWeblog.httpreq.abort();
		} else {
			blogger.httpreq.abort();
		}
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("postbutton").label = bloggerbundle.getString("Post");
	} else {
		if (dsPrefs.getBoolPref("SpellCheckOnPost")) {
			// goDoCommand won't work for some reason.
			eval(document.getElementById("cmd_spell").getAttribute("oncommand"));
		}
		document.getElementById("postbutton").label = bloggerbundle.getString("Cancel");
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = bloggerbundle.getString("Posting");
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		this.posting = true;
		if (usemeta) {
			dsPosts.metaPostToServer();
		} else {
			dsPosts.bloggerPostToServer();
		}
	}
}

dsPosts.resetPostParameters = function() {
	dsMidas.setUpMidas();
	document.getElementById("subject").value = null;
	document.getElementById("draftcheck").checked = false;	
	document.getElementById("categories").selectedIndex = 0;
}

// Start Blogger-specific stuff.

dsPosts.bloggerPostToServer = function() {
	dsMidas.updateSourceTab();
	var post = new AtomPost();
	var subjectbox = document.getElementById("subject");
	if (subjectbox.value.trim().length > 0) {
		post.addTitle(subjectbox.value);
	}
	
	var now = new Date();
	
	post.setDate(now);	
		
	var draftpost = false;
	if (document.getElementById("draftcheck").checked) {
		draftpost = true;
	}
	
	try {
		post.addPost(document.getElementById("messagesource").value);
	} catch(e) {
		alert(e);
		dsPosts.sendPost();
		return;
	}
	
	post.addCustomTag("draft", "http://purl.org/atom-blog/ns#", draftpost);
	blogger.httpreq = new XMLHttpRequest();
	blogger.httpreq.onreadystatechange = dsPosts.bloggerPostHandler;
	blogger.httpreq.onerror = function() {
		alert(bloggerbundle.getString("ErrorConnecting"));
		dsPosts.sendPost();
	}
	
	var bloglist = document.getElementById("bloglist");
	var sendto = blogger.blogs[bloglist.selectedIndex]["post"];
	blogger.httpreq.open("POST", sendto, true);
	document.getElementById("statuswhat").value = bloggerbundle.getString("PostingTo") + " " + bloglist.label;
	blogger.httpreq.send(post.atom);
}

dsPosts.bloggerPostHandler = function() {
	if (dsPosts.posting) {
		if (blogger.httpreq.readyState == 4) {
			if ((blogger.httpreq.status == 200) || (blogger.httpreq.status == 201)) {
				dsPosts.resetPostParameters();
			} else {
				alert(bloggerbundle.getString("ErrorPosting") + " " + blogger.httpreq.responseText);
			}
			dsPosts.sendPost();
		}
	}	
}

function OpenHistory() {
	var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var history = windowmanager.getMostRecentWindow("deepestsender:history"); 
	if (history) {
		history.focus();
	} else {
		window.openDialog("history.xul","dshistory","chrome,dependent,resizable", blogger, metaWeblog, usemeta);
	}
}
